"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.get = exports.getAll = void 0;
const connection_1 = require("../utils/connection");
/**
 * @function getAll
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @returns {FilteredResponse}
 */
function getAll(baseUrl, headers) {
    const url = baseUrl + `/cxs/rules`; // rules endpoint
    return connection_1.callUnomi("GET", url, null, headers, 200); // return result object
}
exports.getAll = getAll;
/**
 * @function get
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {string} ruleId
 * @returns {FilteredResponse}
 */
function get(baseUrl, headers, ruleId) {
    const url = baseUrl + `/cxs/rules/${ruleId}`; // rules endpoint
    return connection_1.callUnomi("GET", url, null, headers, 200); // return result object
}
exports.get = get;
/**
 * @function create
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {object} properties
 * @returns {FilteredResponse}
 */
function create(baseUrl, headers, properties) {
    const url = baseUrl + `/cxs/rules`; // rules endpoint
    return connection_1.callUnomi("POST", url, properties, headers, 204); // return result object
}
exports.create = create;
