import { FilteredResponse } from "../../src/types/sdkResponse";
import { UsedProperties } from "../../src/types/segments";
/**
 * @function getAll
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {string} sortOrder
 * @param {number} limit
 * @param {number} offset
 * @returns {FilteredResponse}
 */
export declare function getAll(baseUrl: string, headers: Record<string, string>, sortOrder: string, limit: number, offset: number): FilteredResponse;
/**
 * @function get
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {string} segmentId
 * @returns {FilteredResponse}
 */
export declare function get(baseUrl: string, headers: Record<string, string>, segmentId: string): FilteredResponse;
/**
 * @function create
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {object} properties
 * @returns {FilteredResponse}
 */
export declare function create(baseUrl: string, headers: Record<string, string>, params: UsedProperties): FilteredResponse;
/**
 * @function update
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {object} properties
 * @returns {FilteredResponse}
 */
export declare function update(baseUrl: string, headers: Record<string, string>, params: UsedProperties): FilteredResponse;
/**
 * @function delete
 * @param {string} baseUrl
 * @param {Record<string, string>} headers
 * @param {string} segmentId
 * @returns {FilteredResponse}
 */
export declare function deleteSegment(baseUrl: string, headers: Record<string, string>, segmentId: string): FilteredResponse;
