import { JsonGenericProperty } from "./generics.d";

export interface CreateProperties { // object structure for profile
    itemId: string | number;
    itemType: string;
    version: number;
    properties: JsonGenericProperty;
    systemProperties: JsonGenericProperty;
    segments: string[];
    scores: JsonGenericProperty;
    mergedWith: string;
    consents: any;
}

export interface ExistingProperties { // object structure for existing properties
    itemType: string;
    tag: string;
    isSystemTag?: boolean;
}

export interface GetByProperty { // object structure for query to get profiles
    query: string;
    limit?: number;
    offset?: number;
    forceRefresh?: boolean;
}

export interface QueryConfig { // object structure for query
    limit?: number;
    offset?: number;
    forceRefresh?: boolean;
    operator: "and" | "or";
}